
 var fs = require("fs");
 var util = require("util");

 var logLevel = {
     'L_Low'     : 0,
     'L_Normal'  : 1,
     'L_High'    : 2,
     'L_Extended': 3,
     'L_Full'    : 4
 };

 var ___logLevel = {
     "0" : 'L_Low',
     "1" : 'L_Normal',
     "2" : 'L_High',
     "3" : 'L_Extended',
     "4" : 'L_Full'
 };

 var ListCustomLogFiles = {
     //TODO: make its works :)
     // file : path and name
     // condition : array of lofLevel's and logType's
 };
 var CurrentLogLevel = logLevel.L_Normal;
 var ConsoleFile = '';
 var writeToFile = '';
 var colors = {
     default : 0,
     cyan    : 36,
     lcyan   : '1;36',
     red     : 31,
     lred    : '1;31',
     yellow  : 33,
     bWhite  : 1
 };

 // Colours
 //
 // \033[0m    все атрибуты по умолчанию
 // \033[1m    жирный шрифт (интенсивный цвет)
 // \033[2m    полу яркий цвет (тёмно-серый, независимо от цвета)
 // \033[4m    подчеркивание
 // \033[5m    мигающий
 // \033[7m    реверсия (знаки приобретают цвет фона, а фон -- цвет знаков)
 //
 // \033[22m    установить нормальную интенсивность
 // \033[24m    отменить подчеркивание
 // \033[25m    отменить мигание
 // \033[27m    отменить реверсию
 //
 // \033[30    чёрный цвет знаков
 // \033[31    красный цвет знаков
 // \033[32    зелёный цвет знаков
 // \033[33    желтый цвет знаков
 // \033[34    синий цвет знаков
 // \033[35    фиолетовый цвет знаков
 // \033[36    цвет морской волны знаков
 // \033[37    серый цвет знаков
 //
 // \033[40    чёрный цвет фона
 // \033[41    красный цвет фона
 // \033[42    зелёный цвет фона
 // \033[43    желтый цвет фона
 // \033[44    синий цвет фона
 // \033[45    фиолетовый цвет фона
 // \033[46    цвет морской волны фона
 // \033[47    серый цвет фона

 Object.defineProperty(global, '__stack', {
     configurable: true,

     get: function(){
         var orig = Error.prepareStackTrace;

         Error.prepareStackTrace = function(_, stack){ return stack; };

         var err = new Error;

         Error.captureStackTrace(err, arguments.callee);

         var stack = err.stack;

         Error.prepareStackTrace = orig;

         return stack;
     }
 });

 Object.defineProperty(global, '__line', {
     configurable: true,

     get: function(){
         return __stack[1].getLineNumber();
     }
 });

function formatDate(formatDate, formatString){
  
    var yyyy = formatDate.getFullYear();
    var yy = yyyy.toString().substring(2);
    var m = formatDate.getMonth() + 1;
    var mm = m < 10 ? "0" + m : m;
    var d = formatDate.getDate();
    var dd = d < 10 ? "0" + d : d;

    var  h = formatDate.getHours();
    var  hh = h < 10 ? "0" + h : h;
    var  n = formatDate.getMinutes();
    var  nn = n < 10 ? "0" + n : n;
    var  s = formatDate.getSeconds();
    var  ss = s < 10 ? "0" + s : s;

    formatString = formatString.replace(/yyyy/i, yyyy);
    formatString = formatString.replace(/yy/i, yy);
    formatString = formatString.replace(/mm/i, mm);
    formatString = formatString.replace(/m/i, m);
    formatString = formatString.replace(/dd/i, dd);
    formatString = formatString.replace(/d/i, d);
    formatString = formatString.replace(/hh/i, hh);
    formatString = formatString.replace(/h/i, h);
    formatString = formatString.replace(/nn/i, nn);
    formatString = formatString.replace(/n/i, n);
    formatString = formatString.replace(/ss/i, ss);
    formatString = formatString.replace(/s/i, s);

    return formatString;  
}

Date.prototype.myFormat = function(format){
    return formatDate(this, format);
};

function PrintLine(source, title, _this, txt, enableLogWhere){
	var trace = getTrace(source[1]);
	var string = '[' + ((title && (typeof title === 'string') && (title.length > 0)) ? (title + ' ') : '');

	if (enableLogWhere == true) {
        var fullTrace = "";

        for (var tt = 1; tt < source.length; tt++){
            var yy = getTrace(source[tt]);

            fullTrace += util.format("%s:%d\n", yy.file, yy.lineno);
        }

        string += util.format("%s]: %s\n", trace.timestamp, util.format.apply(_this, [txt])) + fullTrace;
	} else
    if ((enableLogWhere == false) || (enableLogWhere == undefined)){
		string += util.format("%s]: %s",  trace.timestamp, util.format.apply(_this, [txt]));
	}
	
	return string;
}

function getTrace(call) {
	var curDate = new Date();
	
	return {
		file: call.getFileName(),
		lineno: call.getLineNumber(),
		timestamp: curDate.myFormat('dd:mm:yyyy hh:nn:ss')
	};
}

function colourise(colourCode, string, background) {
    var backcolor = (!background) ? "\033[0m" : background;

	return "\033[" + colourCode + "m"  + string + backcolor;
}

function ExtractPath(Path){
     for (var i = Path.length - 1; i >= 0; i--){
         if ((Path[i] === '\\') || (Path[i] === '/')) {
             return Path.slice(0, i);
         }
     }

     return Path;
 }

function ExtractFileName (Path){
     var count = 0;

     for (var i = Path.length - 1; i >= 0; i--){
         count ++;

         if ((Path[i] === '\\') || (Path[i] === '/')) {
             return Path.slice(i + 1, i + count);
         }
     }

     return Path;
 }

 function LogToFile(_text, file){
	if (file || file !== ''){
        var _path = ExtractPath(file);
        var _file = ExtractFileName(file);

        writeToFile += _text + '\n';

        fs.stat(_path, function(err){
            if (err){
                process.stdout.write(colourise(colors.red, '  >> [err]: Path not found: ' + _path) + "\n");

                process.nextTick(function(){
                    if (writeToFile != ''){
                        fs.appendFile('./' + _file, writeToFile, 'ascii', function(err){});

                        writeToFile = '';
                    }
                })
            } else {
                process.nextTick(function(){
                    if (writeToFile != ''){
                        fs.appendFile(file, writeToFile, 'ascii', function(err){});

                        writeToFile = '';
                    }
                })
            }
        });
	}
}

 function _log(stack, title, color, arg){
     var _logLevel = CurrentLogLevel;
     var _txt      = arg[0];
     var _logWhere = false;
     var _logFile  = undefined;

     if (Object.prototype.toString.call( arg[1] ) == '[object Object]'){
         if (arg[1].logLevel) _logLevel = arg[1].logLevel;
         if (arg[1].logWhere) _logWhere = arg[1].logWhere;
         if (arg[1].logFile)  _logFile  = arg[1].logFile;
     } else {
         if (arg.length > 1) {
             if (___logLevel[arg[arg.length - 1]]) {
                 _logLevel = arg[arg.length - 1];
             }
         }

         if (arg[1] && (Object.prototype.toString.call( arg[1] ) == '[object Boolean]')){
             _logWhere = arg[1];
         }
     }

     if (!_logLevel || parseInt(_logLevel) <= parseInt(CurrentLogLevel)){
         var text = PrintLine(stack, title, this, _txt, _logWhere);

         process.stdout.write(colourise(color, text) + "\n");

         if (_logFile) {
             LogToFile(text, _logFile)
         } else {
             LogToFile(text, ConsoleFile);
         }
     }
 }

 function AddCustomLogFile(param){

 }

module.exports = {
	log      : function(){ _log.apply(this, [__stack, 'log ', colors.default, arguments]) },
	info     : function(){ _log.apply(this, [__stack, 'info', colors.lcyan,   arguments]) },
    err      : function(){ _log.apply(this, [__stack, 'err ', colors.lred,    arguments]) },
    warn     : function(){ _log.apply(this, [__stack, 'warn', colors.yellow,  arguments]) },
    important: function(){ _log.apply(this, [__stack, '  ! ', colors.bWhite,  arguments]) },

	DublicateToFile: function(fileName){
		ConsoleFile = fileName;
	},

    AddCustomLofFile : AddCustomLogFile,

    logLevel    : logLevel,
    SetLogLevel : function(ll){
        CurrentLogLevel = ll;
    }
};


