
 var Service        = require('./service.js');
 var console        = require('console-plus');

 var UniversalParser  = require('./web_client_connect.js').UniversalParser;

 var maxDataLength = 1000000;

 function Receive_POST_Data (req, res, CommandParser){
 	var postData = '';

	console.log("Receive POST data -=START=-", console.logLevel.L_Full);

	req.addListener("data", function(postDataChunk) {
		postData += postDataChunk;

        if (postData.length > maxDataLength){
            console.err("To long POST data. Break connection.");

            req.removeAllListeners();
        }
	});
	
	req.addListener("end", function() {
		console.log(' POST data length: ' + postData.length, console.logLevel.L_Full);
		console.log(' POST data: ' + postData, console.logLevel.L_Full); // + "\nCRC: " + Service.CRC32(postData)
		console.log("Receive POST data -=END=-", console.logLevel.L_Full);
		
		CommandParser.apply(req, [postData,  function(_outData){
			console.info("Send to client DATA: " + _outData, console.logLevel.L_Extended);
			
			if (_outData) res.end(_outData);
		}]);
	});
 }

 function CommandParser(_dataIn, onFinish){
	 var reqData = Service.Get_CMD(_dataIn);

     UniversalParser.apply(this, [reqData.CMD, reqData.DATA, onFinish]);
 }
 
 exports.Parse = function(req, res){
 	Receive_POST_Data(req, res, CommandParser);
 };
 exports.__receiveData = Receive_POST_Data;
