
 var Service	= require('./service.js');
 var console	= require('console-plus');
 var URL        = require('url');
 var SendFile   = require('send');

 var POST_Processing = require('./post_parser.js');    console.info("POST_Processing loaded...");

 var Resources = {
     "0" : {
         host 	  : MCServer.Host,
         pathWWW  : '/',
         runFunc  : false,
         source	  : MCPathes.WWW
     },
     "1" : {
         host 	  : MCServer.Host,
         pathWWW  : '/stat.txt',
         runFunc  : true,
         CallBack : function(req, res, localPath, opt){
             POST_Processing.__receiveData(req, res, function(data, out){
                 var crc = Service.CRC32(data);
                 var _ip = req.socket.remoteHostIp;

                 Service.AddTextToFile('', crc + ".json", Service.formatDate(new Date(), 'dd.mm.yyyy.hh.nn.ss') + '\n' + _ip + '\n' + data, function(){
                     console.info('Statistics received from: ' + _ip);

                     out('OK');
                 });
             });
         }
     }
     /*{ 	== пример временной ссылки на файл ==
		host		: 'localhost',
		pathWWW		: '/druygh57gerygb54iy7gbv495g9g694gf76gg96eb4tf6ge45g9/',
		source		: 'e:/anime.xlsx',
        email       : "gifer@i.ua",
		TTL			: '7'
	 }  */
 };

 var Router = {};

 /**
  * @return {undefined}
  */
 Router.ParseRequest = function(req, res, opt){
 	var _IDX   = -1;
	var maxLen = -1;
    var _res   = false;
    var _path  = URL.parse(req.url).pathname;

    console.log("Request for " + _path + " received.", console.logLevel.L_Full);

    if (_path) {
        for (var i in Resources){
            if (_path == Resources[i].pathWWW) {
                _IDX = i;

                break;
            } else
            if (_path.indexOf(Resources[i].pathWWW) === 0){
                var _curLen = Resources[i].pathWWW.split('/').length - 1;

                if (maxLen < _curLen){
                    _IDX = i;
                    maxLen = _curLen;
                }
            }
        }

        if (_IDX != -1){
            var localPath = Service.GetSubstringFrom(_path, Resources[_IDX].pathWWW);

            if (Resources[_IDX].runFunc){
                Resources[_IDX].CallBack(req, res, localPath, opt);

                _res = true;
            } else {
                switch (req.method){
                    case "GET" :
                        var uri = URL.parse(req.url).pathname;

                        SendFile(req, uri)
                            .root('./www')
                            .on('error', function error(err) {
                                res.statusCode = err.status || 500;

                                res.end('Sorry, path ' + uri + ' not found :(');

                                console.err('SendFile Error:' + err.message);
                            })
                            .on('directory', function redirect(){
                                res.statusCode = 301;

                                res.setHeader('Location', req.url + '/');
                                res.end('Redirecting to ' + req.url + '/');
                            })
                            .pipe(res); //;

                        _res = true;
                    break;

                    case "POST": POST_Processing.Parse(req, res); _res = true; break;
                }
            }
        }
    } else {
        console.err('Fucking path error');
    }

    return _res;
 };

 /**
  * @return {number}
  */
 Router.AddRoutPath = function(_rout){
 	var Option = Service.Extend({
		host : MCServer.Host,
		pathWWW : '/',
		source : './',
		TTL : ''
	}, _rout || {});

    var res = undefined;
    var idx = Service.RandomHash(5);

    if (Resources[idx]) {
        res = Router.AddRoutPath(Option)
    } else {
        Resources[idx] = Option;

        res = idx;
    }

    return res;
 };
 
 Router.AddRandomPath = function(_opt){
 	var Option = Service.Extend({
		host     : MCServer.Host,
		pathWWW  : '/',
		source   : './',
		email    : 'support@nsoft-s.com',
        fileName : '/img.jpg',
		TTL      : ''
	}, _opt || {});
	
	Option.pathWWW = '/' + Service.RandomHash(32) + Option.fileName;// + Service.ExtractFileName(Option.source);
	
	// Непостредственная вставка виртуального пути в список Роутер_лист
    var idx = Router.AddRoutPath(Option);
	
	console.info("Added random path: " + Option.pathWWW + " for file: " + Option.source, console.logLevel.L_Extended);
	console.log("Total pathes: " + JSON.stringify(Resources), console.logLevel.L_Extended);

	return [idx, Option.pathWWW];
 };
 
 Router.DelRoutPath = function(idx){
     if (Resources[idx]) {
         delete Resources[idx];
     }
 };
 
 Router.LoadPathes = function(){
 };
 
 exports.GO             = Router.ParseRequest;
 exports.AddRandomPath  = Router.AddRandomPath;
 exports.AddPath        = Router.AddRoutPath;
 exports.LoadPathes     = Router.LoadPathes;
 exports.DelRoutPath    = Router.DelRoutPath;
