
var CRLF = "\r\n";
//var BR   = "\v";
var CR   = "\r";
var LF   = "\n";

var Service	  = require('./service.js');
var console	  = require('console-plus');
var MCConnect = require('./mcconnect.js');
var CMD       = MCConnect.CMD;

var inc             = 0;
var ParseFunctions  = {};
var key             = "supersecretkey";

/**
 * @return {string}
 */
function SessionID_Generator (){
    inc ++;

    return (inc + (new Date()).getTime() + Service.RandomHash(5)).toString() + "";
}

function _Auth(_data, cmd, CallBack, Host){
    var id = SessionID_Generator();

    var data = Service.StringToObj(_data);

    MCConnect.MakeClientConnection({
        login      : data.UIN,
        pass       : (data.RM) ? Service.Decrypt(key, data.Pass) : data.Pass,

        Gender               : data.Gender,
        Email                : data.Email,
        SecretQuestionNumber : data.SecretN,
        SecretAnswer         : data.SecretA,
        ClientType           : data.ClientType || "web",
        ServPass             : (data.ServPass && data.RM) ? Service.Decrypt(key, data.ServPass) : (data.ServPass || ""),

        host       : MCServer.Host,
        port       : MCServer.MCPort,

        clientIP   : [Host],

        sessionID  : id,
        authType   : cmd
    });

    if (CallBack){
        var pwd = "";

        if (data.RM) {
            pwd = "";// CR + data.Pass + CR + (data.ServPass || "");
        } else {
            pwd = CR + Service.Encrypt(key, data.Pass) + CR + ((data.ServPass) ? Service.Encrypt(key, data.ServPass) : "");
        }

        CallBack(CMD.OK + CR + id + pwd);
    } else {
        console.err('Not assigned CallBack on CMD:' + cmd);
    }
}

ParseFunctions[CMD.Login]       = function Login(_data, SendDataToWebClient, Host){
    _Auth(_data, CMD.Login, SendDataToWebClient, Host);
};

ParseFunctions[CMD.Register]    = function Register(_data, SendDataToWebClient, Host){
    _Auth(_data, CMD.Register, SendDataToWebClient, Host);
};

ParseFunctions[CMD.Ping]        = function Ping(_data, SendDataToWebClient){ // sessionID
    var data = _data.split(CR);
    var sID  = data[0];
    //var sID = parseInt(sessionID.slice(1, sessionID.length - 1));

    if (MCConnect.UsersInBuffer.CheckUserInBuf(sID)){
        var out = MCConnect.UsersInBuffer.GetFromInBuf(sID, true);

        if (SendDataToWebClient) SendDataToWebClient(CMD.Ping + CR + out);

        MCConnect.SendDataToServer(sID, MCConnect.CMD.cs_ping);
    } else {
        var out = {};
            out[MCConnect.CMD.sc_drop_connect] = {};

        SendDataToWebClient(CMD.Ping + CR + JSON.stringify(out));
    }
};

function UniversalParser (_CMD, _data, SendDataToWebClient){
    if (ParseFunctions.hasOwnProperty(_CMD)) {
        var _host = this.socket.remoteHostIp;

        ParseFunctions[_CMD](_data, SendDataToWebClient, _host)
    } else {
        var data = _data.split(CR);
        var sID  = data.shift().toString();

        MCConnect.SendDataToServer(sID, _CMD, data);

        if (SendDataToWebClient) SendDataToWebClient(CMD.OK);
    }
}

exports.UniversalParser = UniversalParser;